package com.yihu.ehr.framework.util;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.stereotype.Service;

/**
 * 创建一个ObjectMapper派生类，用于注解Bean的创建。
 *
 * 因为性能原因，并且此类是线程安全的，此类被缓存。参见：http://wiki.fasterxml.com/JacksonBestPracticesPerformance
 *
 * @implNote 此bean不可用于手工获取的成员变量中。
 *
 * @author Sand
 * @version 1.0
 * @created 2015.08.14 13:45
 */
@Service("objectMapper")
public class ObjectMapperExt extends ObjectMapper {
}
