package com.yihu.ehr.framework.util.controller;

import com.yihu.ehr.framework.model.DetailModelResult;
import com.yihu.ehr.framework.util.log.Logger;
import com.yihu.ehr.framework.util.log.LoggerFactory;
import com.yihu.ehr.framework.util.operator.CollectionUtil;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author HZY
 * @vsrsion 1.0
 * Created at 2016/8/8.
 */
public class BaseController extends AbstractController {
    static private final Logger logger = LoggerFactory.getLogger(BaseController.class);

    public BaseController() {
    }

    protected ModelAndView handleRequestInternal(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        return null;
    }

    public DetailModelResult getResult(List detaiModelList, int totalCount, int currPage, int rows) {
        DetailModelResult result = new DetailModelResult();
        result.setSuccessFlg(true);
        result.setDetailModelList(detaiModelList);
        result.setTotalCount(totalCount);
        result.setCurrPage(currPage);
        result.setPageSize(rows);
        if(result.getTotalCount() % result.getPageSize() > 0) {
            result.setTotalPage(result.getTotalCount() / result.getPageSize() + 1);
        } else {
            result.setTotalPage(result.getTotalCount() / result.getPageSize());
        }

        return result;
    }

    public String encodeStr(String str) {
        try {
            return str == null?null:new String(str.getBytes("ISO-8859-1"), "UTF-8");
        } catch (UnsupportedEncodingException var3) {
            logger.error(var3.getMessage());
            return null;
        }
    }

    public List jsonArrayToList(String jsonArray, Class tClass) {
        JSONArray newJsonArray = JSONArray.fromObject(jsonArray);
        List collection = JSONArray.toList(newJsonArray);
        ArrayList list = new ArrayList();
        if(!CollectionUtil.isEmpty(collection)) {
            Iterator it = collection.iterator();

            while(it.hasNext()) {
                JSONObject jsonObj = JSONObject.fromObject(it.next());
                Object model = JSONObject.toBean(jsonObj, tClass);
                list.add(model);
            }
        }

        return list;
    }

    public Object jsonToObject(String json, Class tClass) {
        Object model = JSONObject.toBean(JSONObject.fromObject(json), tClass);
        return model;
    }
}