package com.yihu.hos.system.controller;

import com.yihu.hos.web.framework.model.Result;
import com.yihu.hos.web.framework.util.controller.BaseController;
import com.yihu.hos.system.service.intf.IAppManager;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

/**
 * 应用管理
 */
@RequestMapping("/app")
@Controller
public class AppController extends BaseController {
    @Resource(name = "appManager")
    private IAppManager appManager;

    /**
     * 系统参数列表
     *
     * @param request
     * @return
     */
    @RequestMapping("/getAppList")
    @ResponseBody
    public Result getAppList(HttpServletRequest request) {
        try {
            Map<String, Object> params = new HashMap<>();
            String page = StringUtils.isEmpty(request.getParameter("page")) ? "1" : request.getParameter("page");
            String rows = StringUtils.isEmpty(request.getParameter("rows")) ? "10" : request.getParameter("rows");

            params.put("page", page);
            params.put("rows", rows);
            return appManager.getAppList(params);
        } catch (Exception ex) {
            return Result.error(ex.getMessage());
        }
    }
}
