package com.yihu.hos.web.framework.util.quartz;


import org.quartz.*;

import java.lang.reflect.Method;


/**
 * 调用Rest任务
 */
@DisallowConcurrentExecution
public class ClassJob implements Job {

    private String methodName = "execute";

    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {

        JobDataMap data = context.getJobDetail().getJobDataMap();
        String jobContent = String.valueOf(data.get("jobContent"));
        String jobId = String.valueOf(data.get("jobId"));
        try {
            //调用对应类
            Class cls = Class.forName(jobContent);//包名.类名
            Method method = cls.getMethod(methodName, String.class);//方法名，和参数的类对象
            method.invoke(cls.newInstance(), jobId);//类的实例，和参数
        }
        catch (Exception ex)
        {
            throw new JobExecutionException(ex.getMessage());
        }
    }

}//end RestJob